%Funkcja "P_WGM" - laboriatorium PTS
%Autor: Jakub Zmigrodzki
%Instytut Metrologi i Inzynirii Biomedycznej Politechniki Warszawskiej
%Warszawa, 2008

% funkcja "P_WGM" wyznacza mocy zawarta w zadanym pasmie sygnalu na podstawie 
%widmowej gestosci mocy sygnalu
%parametram wyjciowym jest P - moc sygnalu w zadanym pasmie,

function [P] = P_WGM(WGM, fp, nfft, f1, f2)

% parametrami wejsciowymi sa:
% WGM - wektor reprezentujacy widmowa gestosc mocy sygnalu s,
% fp - czestotliwosc probkowania sygalu s,
% nfft - dlugsc DTF ktora zastosowano do wyznaczenia WGM,
% f1, f2 - czstotliwoci graniczne pasma dla ktorego zostanie oszacowana
% moc.


n1=round((nfft/fp)*f1)+1;
n2=round((nfft/fp)*f2)+1;

if n1<1
    n1=1;
end;

if n2<1
    n2=1;
end;

if n1>length(WGM)
    n1=length(WGM);
end;

if n2>length(WGM)
    n2=length(WGM);
end;

P=sum(WGM(n1:n2))*fp/nfft;