%Funkcja "WA" - laboriatorium PTS
%Autor: Jakub Zmigrodzki
%Instytut Metrologi i Inzynirii Biomedycznej Politechniki Warszawskiej
%Warszawa, 2008

% funkcja "WA" wyznacza widmo amplitudowe sygnalu wejsiowego
%parametrami wyjciowymi sa:
% f - wektor czstotliwosc dla ktorych zostaly wyliczone wartosci widma
% amplitudowego
% WA - wektor wartosci widma aplitudowego
% faza - faza w radianach

function [f, WA, faza] = WA(typ, syg, nfft, fp, typ_wykresu)

% paramety wejsciowe:
% typ - widma jakie zostanie wyliczone:
%     - 'dwustronne'
%     - 'jednostronne'
% syg - sygnal wejsciowy,
% nfft - dlugosc DFT
% fp - czestotliwosc probkowania sygnalu syg,
% typ wykresu - wykres dyskretny, ciagy lub brak wykresu


if isempty(nfft)
    nfft=length(syg);
end;

if isempty(typ)
    typ='jednostronne';
end;

if isempty(typ_wykresu)
    typ_wykresu='';
end;

switch lower(typ)
    case 'dwustronne'
        TF=fftshift(fft(syg,nfft))/nfft;
        WA=abs(TF);
        faza=angle(TF);

        if mod(nfft,2)==0
            f=(-nfft/2:((nfft/2)-1))*(fp/nfft);
        else
            f=(-floor(nfft/2):floor(nfft/2))*(fp/nfft);
        end;
    case 'jednostronne'
        
        TF=fft(syg,nfft);
        
        if mod(nfft,2)==0
            WA=2*abs(TF(1:(nfft/2+1)))/nfft;
            faza=angle(TF(1:(nfft/2+1)));
            f=(0:nfft/2)*(fp/nfft);
        else
            WA=2*abs(TF(1:((nfft+1)/2)))/nfft;
            faza=angle(TF(1:((nfft+1)/2)));
            f=(0:(((nfft+1)/2)-1))*(fp/nfft);
        end;
    otherwise
        disp('Nieznany typ')
end;


switch lower(typ_wykresu)
    case 'dyskretny'
        figure
        stem(f,WA,'k');
        grid on;
        xlabel('f[Hz]');
        ylabel('WA');
        
    case 'ciagly'
        figure
        plot(f,WA,'-k.');
        grid on;
        xlabel('f[Hz]');
        ylabel('WA');
    otherwise
        disp('bez rysunku')
end;
