%Funkcja "spektrogram" - laboriatorium PTS
%Autor: Jakub Zmigrodzki
%Instytut Metrologi i Inzynirii Biomedycznej Politechniki Warszawskiej
%Warszawa, 2008


function [] = spektrogram(x,okno,dl_okna,nfft,fp)

% parametrami wejsciowymi sa:
% x - sygnal wejsciowy
% nfft - dlugosc DFT
% fp - czestotliwosc probkowania sygnalu,
% okno - typ zastosowanj funkcji granic,
% dl_okna - dlugosc okna danych,



if isempty(okno)
    okno='prostokatne';
end;

if isempty(dl_okna)
    dl_okna=round(length(x)/10);
end;

if isempty(nfft)
    nfft=dl_okna*2;
end;

if isempty(fp)
    fp=1;
end;


switch lower(okno)
    case 'prostokatne'
        okno=rectwin(dl_okna);
    case 'hann'
        okno=hann(dl_okna);
    case 'hamming'
        okno=hamming(dl_okna);
    otherwise
        okno=rectwin(dl_okna);
end;


[S,F,T,P] = spectrogram(x,okno,0,nfft,fp);

figure
imagesc(T,F,10*log10(P/max(max(P))),[-100 0]);
xlabel('t[s]');
ylabel('f[Hz]');
axis xy
colorbar
